function [hr,ht,dhr,dht] = rt_rotation_wghts(q1,q2,r,t,MN,M,N)

[n1,T1] = size(q1);
[n2,T2] = size(q2);
if n1 ~= 3 || n2 ~= 3
   error('Surfaces must be in 3-dimensional space');
end
if T1 ~= MN || T2 ~= MN
   error('Surfaces must have the same number of 3-d points');
end

if length(r) ~= M
   error('Length of r must be equal to number of points in x direction');
end
if length(t) ~= N
   error('Length of t must be equal to number of points in y direction');
end
dhr(1) = r(2)-r(1);
dhr(M) = r(M)-r(M-1);
for l = 2:M-1
   dhr(l) = r(l+1)-r(l-1);
end
dht(1) = t(2)-t(1);
dht(N) = t(N)-t(N-1);
for l = 2:N-1
   dht(l) = t(l+1)-t(l-1);
end
hr(:) = dhr(:)/2;
ht(:) = dht(:)/2;
